# coding=utf-8
import os
import argparse

def get_parser():
    parser = argparse.ArgumentParser(description='Continual learning')
    parser.add_argument('--expt_name', type=str, default='test_lamaml',
                    help='name of the experiment')
    
    # model details
    parser.add_argument('--model', type=str, default='single',
                        help='algo to train')

    parser.add_argument('--evaluate_on_tasks', type=str, default='no',
                        help='Evalaute flag')

    parser.add_argument('--parametric_normalization', type=str, default='None', 
                        help='arch to use for training', 
                        choices=[
                        'BN',
                        'LN',
                        'IN',                        
                        'GN',                        
                        'CN'])                            
                        
    parser.add_argument('--arch', type=str, default='linear', 
                        help='arch to use for training', 
                        choices=[
                        'linear', 
                        'pc_cnn', 
                        'pc_cnn_extention', 
                        'pc_cnn_extention[random]', 
                        'pc_cnn_extention[linear-[v0]]',
                        'pc_cnn_extention[linear-simple]',
                        'pc_cnn_extention[linear-simple-n]',                        
                        'pc_cnn_extention[relu]',
                        'pc_cnn_extention[sparse]',
                        'pc_cnn_extention[nn-l5-l6]', 
                        'pc_cnn_extention-non-linear-[e-no-copy]', 
                        'pc_cnn_extention[1]', 
                        'pc_cnn_extention[2]', 
                        'pc_cnn_extention[on-2nd-back]', 
                        'pc_cnn_extention[nn-doub]', 
                        'pc_cnn_extention_nlt[soft]', 
                        'pc_cnn_extention-nl-full',
                        'pc_cnn_extention_v0', 
                        'pc_cnn_extention_v1', 
                        'pc_cnn_extention_v2', 'pc_cnn_extention_v3'])


    parser.add_argument('--meta_loss', type=str, default='logit',
                        help='Select the meta-loss ',
                        choices=[
                        'logit', 
                        'sim-diff',
                        'contrastive'])


    parser.add_argument('--clip_grad_norm', type=str, default='clip_grad_norm[yes]',
                        help='Select the method for pushing into the ',
                        choices=[
                        'clip_grad_norm[no]', 
                        'clip_grad_norm[yes]'])

    parser.add_argument('--const_normalization', type=str, default='no',
                        help='Select the method for normalization ',
                        choices=[
                        'no', 
                        'yes'])

    parser.add_argument('--normalization_type', type=str, default='l-norm-2',
                        help='Select the normalization method ',
                        choices=[
                            'l-norm-2',
                            'l-norm-1',
                          'l-norm-inf',
                                 'max',
                             'max_abs'])

    parser.add_argument('--const_normalization_in_loss', type=str, default='no',
                        help='Select the method for normalization ',
                        choices=[
                        'no', 
                        'yes'])

    parser.add_argument('--take_act_for_loss_full', type=str, default= 'yes',
                        help='Select the method applicaton of the loss ',
                        choices=[
                        'no', 
                        'yes'])

    parser.add_argument('--is_ER_active', type=str, default= 'yes',
                        help='Select if experience replay is active ',
                        choices=[
                        'no', 
                        'yes'])
    parser.add_argument('--nonlinearity_at_penultimate', type=str, default= 'sT[hard]',
                        help='Select if experience replay is active ',
                        choices=[
                        'linear',
                        'sT[hard]', 
                        'sT[soft]',
                        'LWTA',
                        'relu'])
    parser.add_argument('--save_dir', type=str, default= '../results',
                        help='Specify the directory folder were the results should be saved.' )                                                
                           
    parser.add_argument('--grad_normalize', type=str, default='grad_normalize[yes]',
                        help='Select the method for pushing into the ',
                        choices=[
                        'grad_normalize[no]', 
                        'grad_normalize[yes]'])

    parser.add_argument('--normalize_act_for_2loss', type=str, default='normalize_act_for_2loss[yes]',
                        help='Choose wheather to normalize the activations for the second loss.',
                        choices=[
                        'normalize_act_for_2loss[no]', 
                        'normalize_act_for_2loss[yes]'])

    parser.add_argument('--is_loss_class_aware', type=str, default='yes',
                        help='Class awareness within the loss.',
                        choices=[
                        'no', 
                        'yes'])

    parser.add_argument('--sampling_type', type=str, default='peace_by_peace_batch', 
                        help = 'Choose the batch construction type.',
                        choices=[
                        'peace_by_peace_batch',
                        'hole_batch'])

    parser.add_argument('--gradents_balance', type=str, default='gradents_balance[yes]',
                        help='Choose wheather to preserve the ratio of the gradients after normalization.',
                        choices=[
                        'gradents_balance[yes]', 
                        'gradents_balance[no]'])  

    parser.add_argument( '--loss_type', type=str, default='xx',
                        help='Select the loss type ',
                        choices=[
                        'neg(xx)', 
                        'xx', 
                        'abs(xx)', 
                        'square(xx)',
                        'abs(x)abs(x)',
                        'log-sum-exp',
                        'contrastive'])

    parser.add_argument('--selective_mem_push', type=str, default='none', 
                        help='Select the method for pushing into the reservoar memory',
                        choices=[
                        'none', 
                        'per_first_epoch', 
                        'per_all_epochs_sparse'])

    parser.add_argument('--normilize_sub_bins', type=str, default='normilize_sub_bins[ON]', 
                        help='Select the method for pushing into the reservoar memory',
                        choices=[
                        'normilize_sub_bins[ON]',
                        'normilize_sub_bins[OFF]'] )

    parser.add_argument('--update_type', type=str, default='joint',
                        help='Choose the update type for ablation',
                        choices=[
                        'separate',
                        'joint',
                        'with-primary-secundary-loss-jointly',
                        'with-primary-secundary-loss-separatly',
                        'with-primary-loss' ])

    parser.add_argument('--sparse_push_val', type=int, default=10,
                        help='Use a sparse push value')

    parser.add_argument('--sub_bin_size', type=int, default=40,
                        help='Use a sub bin for spliting on sub blocks')

    parser.add_argument('--num_of_bins', type=int, default=8,
                        help='Number of sub blocks')

    parser.add_argument('--alpha_non_linearity_type', type=str, default='alpha_non_linearity_type[abs()]',
                        help='Choose the nonlineraity for the meta update of alpha',
                        choices=[
                        'alpha_non_linearity_type[plain]',
                        'alpha_non_linearity_type[relu]',
                        'alpha_non_linearity_type[abs()]'])

    parser.add_argument('--grad_add', type=str, default='grad_add[both_w_lr]',
                        help='Select the gradient addition approach',
                        choices=[
                        'grad_add[no-learning_lr]',
                        'grad_add[single-obj_primary_w_lr]',
                        'grad_add[single-obj_auxilary_w_lr]',
                        'grad_add[both_w_lr]', 
                        'grad_add[both_obj_one_lr]',
                        'grad_add[both_obj_two_lr]'])

    parser.add_argument('--n_hiddens', type=int, default=100,
                        help='number of hidden neurons at each layer')
    parser.add_argument('--n_layers', type=int, default=2,
                        help='number of hidden layers')
    parser.add_argument('--xav_init', default=False , action='store_true',
                        help='Use xavier initialization')


    parser.add_argument('--lambda_strength', type=float, default=1,
                        help='The strenght of the regularization paramter (Lagrangian) for the second objective.')

    parser.add_argument('--log_sum_exp_strength', type=float, default=1,
                        help='The strenght of the logSumExp strenght parameter.')

    parser.add_argument('--block_sparse', type=int, default=0,
                        help='Do we use block sparsity?')

    parser.add_argument('--jump_lag_mem_buff', type=int, default=1,
                        help='The jup lag for the accumulating memory buffer!')

    parser.add_argument('--correction_on', type=int, default=0,
                        help='If one correction is on!')

    # optimizer parameters influencing all models
    parser.add_argument("--glances", default=1, type=int,
                        help="Number of times the model is allowed to train over a set of samples in the single pass setting") 
    parser.add_argument('--n_epochs', type=int, default=1,
                        help='Number of epochs per task')
    parser.add_argument('--batch_size', type=int, default=1,
                        help='the amount of items received by the algorithm at one time (set to 1 across all ' +
                        'experiments). Variable name is from GEM project.')
    parser.add_argument('--replay_batch_size', type=float, default=20,
                        help='The batch size for experience replay.')
    parser.add_argument('--memories', type=int, default=5120, 
                        help='number of total memories stored in a reservoir sampling based buffer')
    parser.add_argument('--lr', type=float, default=1e-3,
                        help='learning rate (For baselines)')

    
    # experiment parameters
    parser.add_argument('--cuda', default=False , action='store_true',
                        help='Use GPU')
    parser.add_argument('--seed', type=int, default=0,
                        help='random seed of model')
    parser.add_argument('--log_every', type=int, default=1000,
                        help='frequency of checking the validation accuracy, in minibatches')
    parser.add_argument('--log_dir', type=str, default='logs/',
                        help='the directory where the logs will be saved')
    parser.add_argument('--tf_dir', type=str, default='',
                        help='(not set by user)')
    parser.add_argument('--calc_test_accuracy', default=False , action='store_true',
                        help='Calculate test accuracy along with val accuracy')

    # data parameters
    parser.add_argument('--data_path', default='data/',
                        help='path where data is located')
    parser.add_argument('--loader', type=str, default='task_incremental_loader',
                        help='data loader to use')
    parser.add_argument('--samples_per_task', type=int, default=-1,
                        help='training samples per task (all if negative)')
    parser.add_argument('--shuffle_tasks', default=False, action='store_true',
                        help='present tasks in order')
    parser.add_argument('--classes_per_it', type=int, default=4,
                        help='number of classes in every batch')
    parser.add_argument('--iterations', type=int, default=5000,
                        help='number of classes in every batch')
    parser.add_argument("--dataset", default="mnist_rotations", type=str,
                    help="Dataset to train and test on.")

    parser.add_argument("--workers", default=6, type=int,
                        help="Number of workers preprocessing the data.")

    parser.add_argument("--validation", default=0., type=float,
                        help="Validation split (0. <= x <= 1.).")

    parser.add_argument("-order", "--class_order", default="old", type=str,
                        help="define classes order of increment ",
                        choices = ["random", "chrono", "old", "super"])

    parser.add_argument("-inc", "--increment", default=5, type=int,
                        help="number of classes to increment by in class incremental loader")
    parser.add_argument('--test_batch_size', type=int, default=100000 ,
                        help='batch size to use during testing.')

    # GNC learning rate parameter
    parser.add_argument('--gnc_lr', type=float, default=.3,
                        help='The GNC learning rate')

    # La-MAML parameters
    parser.add_argument('--opt_lr', type=float, default=1e-1,
                        help='learning rate for LRs')

    parser.add_argument('--opt_lr_e', type=float, default=1e-1,
                        help='second learning rate for LRs')

    parser.add_argument('--opt_wt', type=float, default=1e-1,
                        help='learning rate for weights')
    parser.add_argument('--alpha_init', type=float, default=1e-3,
                        help='initialization for the LRs')
    parser.add_argument('--learn_lr', default=False, action='store_true',
                        help='model should update the LRs during learning')
    parser.add_argument('--sync_update', default=False , action='store_true',
                        help='the LRs and weights should be updated synchronously')

    parser.add_argument('--grad_clip_norm', type=float, default=2.0,
                        help='Clip the gradients by this value')
    parser.add_argument("--cifar_batches", default=3, type=int,
                        help="Number of batches in inner trajectory") 
    parser.add_argument('--use_old_task_memory', default=False, action='store_true', 
                        help='Use only old task samples for replay buffer data')    
    parser.add_argument('--second_order', default=False , action='store_true',
                        help='use second order MAML updates')


   # memory parameters for GEM | AGEM | ICARL 
    parser.add_argument('--n_memories', type=int, default=0,
                        help='number of memories per task')
    parser.add_argument('--memory_strength', default=0, type=float,
                        help='memory strength (meaning depends on memory)')
    parser.add_argument('--steps_per_sample', default=1, type=int,
                        help='training steps per batch')


    # parameters specific to MER 
    parser.add_argument('--gamma', type=float, default=1.0,
                        help='gamma learning rate parameter')
    parser.add_argument('--beta', type=float, default=1.0,
                        help='beta learning rate parameter')
    parser.add_argument('--s', type=float, default=1,
                        help='current example learning rate multiplier (s)')
    parser.add_argument('--batches_per_example', type=float, default=1,
                        help='the number of batch per incoming example')


    # parameters specific to Meta-BGD
    parser.add_argument('--bgd_optimizer', type=str, default="bgd", choices=["adam", "adagrad", "bgd", "sgd"],
                    help='Optimizer.')
    parser.add_argument('--optimizer_params', default="{}", type=str, nargs='*',
                        help='Optimizer parameters')

    parser.add_argument('--train_mc_iters', default=5, type=int,
                        help='Number of MonteCarlo samples during training(default 10)')
    parser.add_argument('--std_init', default=5e-2, type=float,
                        help='STD init value (default 5e-2)')
    parser.add_argument('--mean_eta', default=1, type=float,
                        help='Eta for mean step (default 1)')
    parser.add_argument('--fisher_gamma', default=0.95, type=float,
                        help='')

    return parser
